.Const

.Data?

.Data

include ECProtos.inc ; .Code

AffinityProcedure Proc FastCall Frame hWnd:HWND, uMsg:QWord, wParam:WPARAM, lParam:LPARAM
	Local dwProcess:QWord, dwSystem:QWord

	.If uMsg == WM_INITDIALOG
		Lea Rax, szBuffer
		Mov Byte Ptr [Rax], VK_SPACE
		Inc Rax
		Invoke LoadAppString, IDS_AFFINITY, Rax, 64
		Invoke GetNoEllipsisText, Addr szBuffer
		Invoke GetNoPrefixString, Addr szBuffer
		Invoke SetText, hWnd, Addr szBuffer

		Invoke LoadAndSetText, hWnd, Addr szBuffer, IDS_CANCEL, IDC_AFFINITY_BTNCANCEL
		Invoke LoadAndSetText, hWnd, Addr szBuffer, IDS_OK, IDC_AFFINITY_BTNOK
		Invoke LoadAndSetText, hWnd, Addr szBuffer, IDS_PROCESSORS, IDC_AFFINITY_GROUP1

		Invoke GetCurrentProcess
		Mov Rdi, Rax
		Invoke GetProcessAffinityMask, Rdi, Addr dwProcess, Addr dwSystem
		Mov Rax, dwSystem
		And Rax, 255
		Mov Rbx, Rax
		Invoke String, Rax, Addr szBuffer, ecDecimal
		Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szAffinity, Addr szBuffer
		Invoke ValueA, Addr szBuffer
		And Rax, 255
		Mov Rsi, Rax
		.If (Bx & 1)
			Invoke GetWindowItem, hWnd, IDC_AFFINITY_CHECK1
			Mov Rdi, Rax
			Invoke EnableWindow, Rax, TRUE
			.If (Si & 1)
				Invoke SendMessage, Rdi, BM_SETCHECK, BST_CHECKED, 0
			.EndIf
		.EndIf
		.If (Bx & 2)
			Invoke GetWindowItem, hWnd, IDC_AFFINITY_CHECK2
			Mov Rdi, Rax
			Invoke EnableWindow, Rax, TRUE
			.If (Si & 2)
				Invoke SendMessage, Rdi, BM_SETCHECK, BST_CHECKED, 0
			.EndIf
		.EndIf
		.If (Bx & 4)
			Invoke GetWindowItem, hWnd, IDC_AFFINITY_CHECK3
			Mov Rdi, Rax
			Invoke EnableWindow, Rax, TRUE
			.If (Si & 4)
				Invoke SendMessage, Rdi, BM_SETCHECK, BST_CHECKED, 0
			.EndIf
		.EndIf
		.If (Bx & 8)
			Invoke GetWindowItem, hWnd, IDC_AFFINITY_CHECK4
			Mov Rdi, Rax
			Invoke EnableWindow, Rax, TRUE
			.If (Si & 8)
				Invoke SendMessage, Rdi, BM_SETCHECK, BST_CHECKED, 0
			.EndIf
		.EndIf
		.If (Bx & 16)
			Invoke GetWindowItem, hWnd, IDC_AFFINITY_CHECK5
			Mov Rdi, Rax
			Invoke EnableWindow, Rax, TRUE
			.If (Si & 16)
				Invoke SendMessage, Rdi, BM_SETCHECK, BST_CHECKED, 0
			.EndIf
		.EndIf
		.If (Bx & 32)
			Invoke GetWindowItem, hWnd, IDC_AFFINITY_CHECK6
			Mov Rdi, Rax
			Invoke EnableWindow, Rax, TRUE
			.If (Si & 32)
				Invoke SendMessage, Rdi, BM_SETCHECK, BST_CHECKED, 0
			.EndIf
		.EndIf
		.If (Bx & 64)
			Invoke GetWindowItem, hWnd, IDC_AFFINITY_CHECK7
			Mov Rdi, Rax
			Invoke EnableWindow, Rax, TRUE
			.If (Si & 64)
				Invoke SendMessage, Rdi, BM_SETCHECK, BST_CHECKED, 0
			.EndIf
		.EndIf
		.If (Bx & 128)
			Invoke GetWindowItem, hWnd, IDC_AFFINITY_CHECK8
			Mov Rdi, Rax
			Invoke EnableWindow, Rax, TRUE
			.If (Si & 128)
				Invoke SendMessage, Rdi, BM_SETCHECK, BST_CHECKED, 0
			.EndIf
		.EndIf
    .ElseIf uMsg == WM_COMMAND
        Mov Rdi, wParam
        And Rdi, 00000000FFFFFFFFH
        Mov Rsi, Rdi
        Shr Edi, 16
        And Esi, 0000FFFFH
        Invoke OnAffinityCommand, hWnd, Rsi, Rdi, lParam
		Jmp @F
    .ElseIf uMsg == WM_CLOSE
        Invoke IsModal, hWnd
        .If Rax
            Invoke EndModal, hWnd, IDCANCEL
            Mov Rax, TRUE   ;Return TRUE
            Jmp @F
        .EndIf
    .EndIf
    Xor Rax, Rax    ;Return FALSE
@@:	Ret
AffinityProcedure EndP

OnAffinityCommand Proc FastCall Private Frame Uses Rdi hWndParent:HWND, uCtlID:QWord, uCode:QWord, hWndChild:HWND
	Local dwProcess:QWord, dwSystem:QWord

    Mov hWndParent, Rcx
    Mov uCtlID, Rdx
    Mov uCode, R8
    Mov hWndChild, R9

	Mov Rax, uCtlID
	.If Eax == IDC_AFFINITY_BTNOK
		Mov Rax, uCode
		.If Eax == BN_CLICKED
			Mov dwProcess, 0
			Invoke GetWindowItem, hWndParent, IDC_AFFINITY_CHECK1
			Invoke SendMessage, Rax, BM_GETCHECK, 0, 0
			.If Rax == BST_CHECKED
				Or dwProcess, 1
			.EndIf
			Invoke GetWindowItem, hWndParent, IDC_AFFINITY_CHECK2
			Invoke SendMessage, Rax, BM_GETCHECK, 0, 0
			.If Rax == BST_CHECKED
				Or dwProcess, 2
			.EndIf
			Invoke GetWindowItem, hWndParent, IDC_AFFINITY_CHECK3
			Invoke SendMessage, Rax, BM_GETCHECK, 0, 0
			.If Rax == BST_CHECKED
				Or dwProcess, 4
			.EndIf
			Invoke GetWindowItem, hWndParent, IDC_AFFINITY_CHECK4
			Invoke SendMessage, Rax, BM_GETCHECK, 0, 0
			.If Rax == BST_CHECKED
				Or dwProcess, 8
			.EndIf
			Invoke GetWindowItem, hWndParent, IDC_AFFINITY_CHECK5
			Invoke SendMessage, Rax, BM_GETCHECK, 0, 0
			.If Rax == BST_CHECKED
				Or dwProcess, 16
			.EndIf
			Invoke GetWindowItem, hWndParent, IDC_AFFINITY_CHECK6
			Invoke SendMessage, Rax, BM_GETCHECK, 0, 0
			.If Rax == BST_CHECKED
				Or dwProcess, 32
			.EndIf
			Invoke GetWindowItem, hWndParent, IDC_AFFINITY_CHECK7
			Invoke SendMessage, Rax, BM_GETCHECK, 0, 0
			.If Rax == BST_CHECKED
				Or dwProcess, 64
			.EndIf
			Invoke GetWindowItem, hWndParent, IDC_AFFINITY_CHECK8
			Invoke SendMessage, Rax, BM_GETCHECK, 0, 0
			.If Rax == BST_CHECKED
				Or dwProcess, 128
			.EndIf
			.If dwProcess
				Invoke GetCurrentProcess
				Invoke SetProcessAffinityMask, Rax, dwProcess
				Invoke String, dwProcess, Addr szBuffer, ecDecimal
				Invoke SetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szAffinity, Addr szBuffer
			.EndIf
			Invoke EndModal, hWndParent, IDOK
@@:			Mov Eax, TRUE
			Jmp L2
		.EndIf
	.ElseIf Eax == IDC_AFFINITY_BTNCANCEL
		Mov Rax, uCode
		.If Eax == BN_CLICKED
			Invoke SendMessage, hWndParent, WM_CLOSE, 0, 0
			Jmp @B
		.EndIf
	.ElseIf Eax == IDC_AFFINITY_CHECK1 || Eax == IDC_AFFINITY_CHECK2 || Eax == IDC_AFFINITY_CHECK3 || Eax == IDC_AFFINITY_CHECK4 || Eax == IDC_AFFINITY_CHECK5 || Eax == IDC_AFFINITY_CHECK6 || Eax == IDC_AFFINITY_CHECK7 || Eax == IDC_AFFINITY_CHECK8
		Mov Rax, uCode
		.If Eax == BN_CLICKED
			Invoke GetWindowItem, hWndParent, IDC_AFFINITY_BTNOK
			Mov Rdi, Rax
			Invoke EnableWindow, Rax, TRUE
			Invoke SetDefault, Rdi, TRUE
			Jmp @B
		.EndIf
	.EndIf
    Xor Rax, Rax    ;Return FALSE
L2:	Ret
OnAffinityCommand EndP
